Bug 911229 - Review Request: nodejs-vows - Asynchronous behaviour-driven development (BDD) and continuous integration
Summary: Review Request: nodejs-vows - Asynchronous behaviour-driven development (BDD)...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Tom Hughes
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 911030
Blocks:
TreeView+ depends on / blocked
 
Reported: 2013-02-14 15:36 UTC by Jamie Nguyen
Modified: 2013-04-27 03:11 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2013-04-19 05:32:11 UTC
tom: fedora-review+
pbabinca: fedora-cvs+


Attachments (Terms of Use)

Description Jamie Nguyen 2013-02-14 15:36:52 UTC
Spec URL: http://jamielinux.fedorapeople.org/mocha/nodejs-vows.spec
SRPM URL: http://jamielinux.fedorapeople.org/mocha/SRPMS/nodejs-vows-0.7.0-1.fc18.src.rpm
Fedora Account System Username:

Description:
Asynchronous behaviour-driven development (BDD) and continuous integration

Comment 1 Tom Hughes 2013-02-27 09:03:16 UTC
Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
[!]: Package contains no bundled libraries.

lib/assert/error.js - adapted from mocha
lib/assert/utils.js - taken from node/lib/assert.js
lib/utils/wildcard.js - looks like it may have come from somewhere?
lib/vows/coverage/report-html.js - adapted from mocha

[!]: License field in the package spec file matches the actual license.

lib/utils/wildcard.js - under Apache 2.0

[!]: Rpmlint is run on all installed packages.

Checking: nodejs-vows-0.7.0-1.fc19.src.rpm
          nodejs-vows-0.7.0-1.fc19.noarch.rpm
nodejs-vows.src: W: spelling-error Summary(en_US) behaviour -> behavior
nodejs-vows.noarch: W: no-manual-page-for-binary vows


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[-]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[!]: Package contains no bundled libraries.
[x]: Changelog in prescribed format.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Sources contain only permissible code or content.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[!]: Package complies to the Packaging Guidelines
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. No licenses
     found. Please check the source files for licenses manually.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named using only allowed ASCII characters.
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: Package do not use a name that already exist
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package installs properly.
[x]: Package is not relocatable.
[x]: Requires correct, justified where necessary.
[x]: CheckResultdir
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file is legible and written in American English.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 10240 bytes in 2 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
[-]: SourceX / PatchY prefixed with %{name}.
     Note: Source0 (vows-0.7.0.tgz)
[x]: SourceX is a working URL.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[!]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: nodejs-vows-0.7.0-1.fc19.src.rpm
          nodejs-vows-0.7.0-1.fc19.noarch.rpm
nodejs-vows.src: W: spelling-error Summary(en_US) behaviour -> behavior
nodejs-vows.src: W: spelling-error %description -l en_US behaviour -> behavior
nodejs-vows.noarch: W: spelling-error Summary(en_US) behaviour -> behavior
nodejs-vows.noarch: W: spelling-error %description -l en_US behaviour -> behavior
nodejs-vows.noarch: W: only-non-binary-in-usr-lib
nodejs-vows.noarch: W: dangling-symlink /usr/lib/node_modules/vows/node_modules/eyes /usr/lib/node_modules/eyes
nodejs-vows.noarch: W: dangling-symlink /usr/lib/node_modules/vows/node_modules/diff /usr/lib/node_modules/diff
nodejs-vows.noarch: W: no-manual-page-for-binary vows
2 packages and 0 specfiles checked; 0 errors, 8 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint nodejs-vows
nodejs-vows.noarch: W: spelling-error Summary(en_US) behaviour -> behavior
nodejs-vows.noarch: W: spelling-error %description -l en_US behaviour -> behavior
nodejs-vows.noarch: W: only-non-binary-in-usr-lib
nodejs-vows.noarch: W: dangling-symlink /usr/lib/node_modules/vows/node_modules/eyes /usr/lib/node_modules/eyes
nodejs-vows.noarch: W: dangling-symlink /usr/lib/node_modules/vows/node_modules/diff /usr/lib/node_modules/diff
nodejs-vows.noarch: W: no-manual-page-for-binary vows
1 packages and 0 specfiles checked; 0 errors, 6 warnings.
# echo 'rpmlint-done:'



Requires
--------
nodejs-vows-0.7.0-1.fc19.noarch.rpm (rpmlib, GLIBC filtered):
    
    /usr/bin/env
    nodejs(engine)
    npm(diff) < 1.1
    npm(diff) >= 1.0.3
    npm(eyes) >= 0.1.6



Provides
--------
nodejs-vows-0.7.0-1.fc19.noarch.rpm:
    
    nodejs-vows = 0.7.0-1.fc19
    npm(vows) = 0.7.0



MD5-sum check
-------------
http://registry.npmjs.org/vows/-/vows-0.7.0.tgz :
  CHECKSUM(SHA256) this package     : 6eb4f4ac0edd70d50ecf2ea05caf1e7bb5c8e70e937b6ee327ca0fc545371439
  CHECKSUM(SHA256) upstream package : 6eb4f4ac0edd70d50ecf2ea05caf1e7bb5c8e70e937b6ee327ca0fc545371439


Generated by fedora-review 0.3.1 (b71abc1) last change: 2012-10-16
Buildroot used: fedora-rawhide-x86_64
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 911229

Comment 2 Jamie Nguyen 2013-03-02 09:25:51 UTC
> lib/utils/wildcard.js - under Apache 2.0

Added ASL 2.0 to License tag.


> nodejs-vows.src: W: spelling-error Summary(en_US) behaviour -> behavior

Argh. I just grepped to find more occurrences. Will fix in nodejs-expect and nodejs-jasmine-node review requests.


> nodejs-vows.noarch: W: no-manual-page-for-binary vows

I actually don't think anyone will really expect vows to be at /usr/bin/vows so I've removed the symlink.


Spec URL: http://jamielinux.fedorapeople.org/mocha/nodejs-vows.spec
SRPM URL: http://jamielinux.fedorapeople.org/mocha/SRPMS/nodejs-vows-0.7.0-2.fc18.src.rpm


> lib/assert/error.js - adapted from mocha
> lib/assert/utils.js - taken from node/lib/assert.js
> lib/utils/wildcard.js - looks like it may have come from somewhere?
> lib/vows/coverage/report-html.js - adapted from mocha

Not really sure what to do about these. utils.js looks like yet another slightly modified deepEqual :(

Any suggestions?

Comment 3 Tom Hughes 2013-03-09 15:00:24 UTC
I attempted to seek some clarification on the bundling issues and the best advice seems to be to try applying for an exception:

http://lists.fedoraproject.org/pipermail/packaging/2013-March/008913.html

Comment 4 Jamie Nguyen 2013-03-10 16:20:14 UTC
> lib/assert/error.js - adapted from mocha
> lib/assert/utils.js - taken from node/lib/assert.js
> lib/utils/wildcard.js - looks like it may have come from somewhere?
> lib/vows/coverage/report-html.js - adapted from mocha

I have enquired about the origins of wildcard.js:
https://github.com/cloudhead/vows/issues/269

I will apply for an exception if nodejs-should is successful and once upstream get back to me about wildcard.js.

Comment 5 Jamie Nguyen 2013-04-07 19:34:56 UTC
Spec URL: http://jamielinux.fedorapeople.org/mocha/nodejs-vows.spec
SRPM URL: http://jamielinux.fedorapeople.org/mocha/SRPMS/nodejs-vows-0.7.0-4.fc18.src.rpm

* Sun Apr 07 2013 Jamie Nguyen <jamielinux@fedoraproject.org> - 0.7.0-4
- use node-glob instead of wildcard.js, which is bundled from unknown origins
- add a more detailed %%description
- add /usr/bin/vows
- add custom man page


I've also opened an FPC ticket:
https://fedorahosted.org/fpc/ticket/272

Comment 6 Jamie Nguyen 2013-04-17 20:21:59 UTC
Bundling exception approved hurray! :)

Comment 7 Tom Hughes 2013-04-17 20:49:37 UTC
Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package complies to the Packaging Guidelines
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 10240 bytes in 2 files.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Fully versioned dependency in subpackages, if present.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: nodejs-vows-0.7.0-4.fc20.noarch.rpm
nodejs-vows.noarch: W: spelling-error %description -l en_US js -> dis, ks, j
nodejs-vows.noarch: W: only-non-binary-in-usr-lib
nodejs-vows.noarch: W: dangling-symlink /usr/lib/node_modules/vows/node_modules/eyes /usr/lib/node_modules/eyes
nodejs-vows.noarch: W: dangling-symlink /usr/lib/node_modules/vows/node_modules/diff /usr/lib/node_modules/diff
nodejs-vows.noarch: W: dangling-symlink /usr/lib/node_modules/vows/node_modules/glob /usr/lib/node_modules/glob
1 packages and 0 specfiles checked; 0 errors, 5 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint nodejs-vows
nodejs-vows.noarch: W: spelling-error %description -l en_US js -> dis, ks, j
nodejs-vows.noarch: W: only-non-binary-in-usr-lib
nodejs-vows.noarch: W: dangling-symlink /usr/lib/node_modules/vows/node_modules/eyes /usr/lib/node_modules/eyes
nodejs-vows.noarch: W: dangling-symlink /usr/lib/node_modules/vows/node_modules/diff /usr/lib/node_modules/diff
nodejs-vows.noarch: W: dangling-symlink /usr/lib/node_modules/vows/node_modules/glob /usr/lib/node_modules/glob
1 packages and 0 specfiles checked; 0 errors, 5 warnings.
# echo 'rpmlint-done:'



Requires
--------
nodejs-vows (rpmlib, GLIBC filtered):
    /usr/bin/env
    nodejs(engine)
    npm(diff)
    npm(eyes)
    npm(glob)



Provides
--------
nodejs-vows:
    nodejs-vows
    npm(vows)



MD5-sum check
-------------
http://registry.npmjs.org/vows/-/vows-0.7.0.tgz :
  CHECKSUM(SHA256) this package     : 6eb4f4ac0edd70d50ecf2ea05caf1e7bb5c8e70e937b6ee327ca0fc545371439
  CHECKSUM(SHA256) upstream package : 6eb4f4ac0edd70d50ecf2ea05caf1e7bb5c8e70e937b6ee327ca0fc545371439


Generated by fedora-review 0.4.0 (660ce56) last change: 2013-01-29
Buildroot used: compton-rawhide-x86_64
Command line :/usr/bin/fedora-review -m compton-rawhide-x86_64 -b 911229

Comment 8 Tom Hughes 2013-04-17 20:50:10 UTC
Looks good now. Package approved.

Comment 9 Jamie Nguyen 2013-04-17 20:51:50 UTC
Thanks Tom!

Comment 10 Jamie Nguyen 2013-04-17 20:52:44 UTC
New Package SCM Request
=======================
Package Name: nodejs-vows
Short Description: Asynchronous behavior-driven development (BDD) and continuous integration
Owners: jamielinux
Branches: f18 f19 el6
InitialCC:

Comment 11 Pavol Babinčák 2013-04-18 12:08:07 UTC
Git done (by process-git-requests).

Comment 12 Fedora Update System 2013-04-18 19:09:10 UTC
nodejs-vows-0.7.0-4.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/nodejs-vows-0.7.0-4.fc19

Comment 13 Fedora Update System 2013-04-18 19:10:52 UTC
nodejs-vows-0.7.0-4.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/nodejs-vows-0.7.0-4.fc18

Comment 14 Fedora Update System 2013-04-19 04:56:03 UTC
nodejs-vows-0.7.0-4.fc18 has been pushed to the Fedora 18 testing repository.

Comment 15 Fedora Update System 2013-04-27 00:12:58 UTC
nodejs-vows-0.7.0-4.fc18 has been pushed to the Fedora 18 stable repository.

Comment 16 Fedora Update System 2013-04-27 03:11:06 UTC
nodejs-vows-0.7.0-4.fc19 has been pushed to the Fedora 19 stable repository.


Note You need to log in before you can comment on or make changes to this bug.